#include <stdio.h>
#include <stdlib.h>

#include "memmap.h"

#ifdef _WIN32
#include <windows.h>

void sleep( int x) { Sleep( 1000*x); }
#endif

/* get integer random number in range a <= x <= e */
int irand( int a, int e)
{
    double r = e - a + 1;
    return a + (int)(r * rand()/(RAND_MAX+1.0));
}

int main( int argc, char **argv)
{
    int rc, i;
    int *a;
    mappedRegion reg;

    rc = memmap( "xxxmapfilexxx", 12345, 200*sizeof(int), &reg);
    if (rc != 0) {
        printf( "memmap failed, rc = %d\n", rc);
        exit(1);
    }
    a = (int *)memGetAddr( &reg);
    if (200 > memGetLength( &reg)) {
        printf( "mapped region too small\n");
        exit(1);
    }

    srand( time(0));
    for (;;) {
        a[irand(0,199)] = irand(-1000, 1000);
        sleep(1);
    }
}
